<template>
  <div class="centered-item">
    <v-card class="mx-auto" :elevation="24">
      <v-card-text>
        <v-form ref="form">
          <v-row>
            <v-col cols="12">
              <v-autocomplete
                v-model="brand"
                :rules="nameRules"
                :items="info"
                item-text="name"
                item-value="name"
                :return-object="checkTrue"
                dense
                label="Марка"
              ></v-autocomplete>
              <v-autocomplete
                v-model="inputsObject.model"
                :rules="nameRules"
                :items="models"
                item-text="name"
                item-value="name"
                dense
                label="Модель"
              ></v-autocomplete>
              <v-text-field v-model="inputsObject.name" :rules="nameRules" label="Имя" required></v-text-field>
              <v-text-field v-model="inputsObject.email" :rules="emailRules" label="Почта" required></v-text-field>
              <v-text-field
                v-model="inputsObject.phone"
                :rules="phoneRules"
                label="Телефон"
                required
              ></v-text-field>
            </v-col>
          </v-row>
        </v-form>
      </v-card-text>
      <v-card-actions>
        <div class="hidden-res">
          <p></p>
        </div>
        <div class="flex-between">
          <v-btn rounded @click="reset" class="reset">Reset</v-btn>
          <v-btn :rounded="true" color="primary" @click="validate" class="validate">Continue</v-btn>
        </div>
      </v-card-actions>
    </v-card>
  </div>
</template>
<script>
export default {
  data: () => ({
    inputsObject: {
      brand: "",
      model: "",
      name: "",
      email: "",
      phone: ""
    },
    brand: {},
    nameRules: [v => !!v || "Обязательное поле"],
    emailRules: [
      v => !!v || "E-mail обязательное поле",
      v => /.+@.+\..+/.test(v) || "Валидный E-mail"
    ],
    phoneRules: [
      v => !!v || "Телефон обязательное поле",
      v => /^380\d{9}$/.test(v) || "380XXXXXXXXX Только цифры"
    ],
    response: {},
    value: "",
    marks: [],
    info: null,
    models: [],
    checkTrue: true
  }),
  mounted: function() {
    this.$nextTick(function() {
      axios
        .get("/brands")
        .then(({ data }) => {
          console.log(data);
          this.info = data;
          console.log(this.info);
        })
        .catch(({ response }) => {
          console.log(response);
        });
    });
  },
  methods: {
    validate() {
      if (this.$refs.form.validate()) {
        this.inputsObject.brand = this.brand.name;
        axios
          .post("/createLead", this.inputsObject)
          .then(({ data }) => {
            console.log("Response:");
            console.log(data);
            console.log(data.status);
            if (data.status == 200) {
              alert("Форма успешно отправлена!");
            }
          })
          .catch(({ response }) => {
            console.log(response);
            console.log(response.data.errors);
            console.log(response.data.errors.email);
            if (response.data.errors.email == undefined) {
            } else {
              alert("Почта уже используется");
            }
            if (response.data.errors.phone == undefined) {
            } else {
              alert("Телефон уже используется");
            }
          });
      }
    },
    reset: function() {
      if (confirm("Do you really want reset this form?")) {
        this.$refs.form.reset();
        console.log("reset:");
        console.log(this.inputsObject);
      }
    }
  },
  watch: {
    "brand.value": function(val) {
      console.log(this.brand.value);
      // this.brand.value = this.inputsObject.brand;
      // if ((this.brand.value = !"")) {
      // console.log("Undefined");
      // console.log(this.brand.value);
      // } else {
      // this.brand.value = this.inputsObject.brand;
      // console.log("this.inputsObject.brand");
      // console.log(this.inputsObject.brand);
      axios
        .get(`/marks/${this.brand.value}`)
        .then(({ data }) => {
          console.log(data);
          this.models = data;
          console.log(this.models);
        })
        .catch(({ response }) => {
          console.log(response);
        });
      // }
    }
  }
};
</script>
<style >
.centered-item {
  display: flex;
  justify-content: center;
  align-items: center;
  height: 100vh;
}
.validate {
  background-color: #1867c0 !important;
  border-color: #1867c0 !important;
}
.reset {
  margin-right: 10px;
}
.v-card__actions {
  display: flex;
  justify-content: flex-end;
  margin-bottom: 10px;
}
.v-messages__message {
  color: red;
}
.v-card:not(.v-sheet--tile):not(.v-card--shaped) {
  width: 310px;
}
.mdi-check {
  color: green !important;
}

.colPadding {
  padding-top: 0px !important;
}
.v-text-field > .v-input__control > .v-input__slot > .v-text-field__slot {
  font-size: 20px;
  font-family: "ProximaNova-Regular", sans-serif;
}
.v-label .v-label--active .theme--light {
  font-size: 14px;
}
.line {
  margin-top: 30px;
  margin-bottom: 40px;
  width: 100%;
  height: 1px;
  background-color: rgb(216, 216, 216);
  opacity: 0.302;
}
.flex-between {
  display: flex;
  justify-content: space-between;
}
.reset-btn {
  color: #a0a0a0 !important;
}
</style>